Maven 最佳实践之 · 一个好的 parent 依赖基础

版权声明:版权归博主所有,转载请带上本文链接!联系方式:abel533@gmail.com https://blog.csdn.net/isea533/article/details/78449270

使用 parent 控制依赖版本是很常见的事。

如果你有过控制依赖版本的这种经历,你可能就会遇到过第三方版本之间的冲突,本文不介绍如何解决冲突,但是会提供给你一个基本不存在冲突的基础依赖。

得益于 Spring ,尤其是 Spring Boot 对第三方集成提供的 starter。Spring Boot 对可能用到的第三方依赖提供了很好的版本控制,我们就依靠 Spring 提供的 bom 和 dependencies 来实现我们自己的基础依赖。

由于 Spring Boot 2.0 正式版还没有发布,这里提供的是 Spring 4.x 最新版本的依赖,这两个依赖分别如下:

上面截图都只显示部分依赖,完整依赖可以点击上面链接查看

这两个依赖搭配的时候,可以通过上面第一个确定你要选择的 Spring 版本,然后去 Spring Boot 这个依赖中选择和 Spring 版本对应的版本(Spring Boot 中有对 spring-core 的依赖)。上面这两个版本就是目前(2017-11-05)最新的版本。

依据这两个依赖,我们创建一个基础的依赖如下:

<?xml version="1.0" encoding="UTF-8"?>
<project xmlns="http://maven.apache.org/POM/4.0.0"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://maven.apache.org/POM/4.0.0 http://maven.apache.org/xsd/maven-4.0.0.xsd">
    <modelVersion>4.0.0</modelVersion>
    <groupId>tk.mybatis</groupId>
    <artifactId>spring-dependencies</artifactId>
    <packaging>pom</packaging>
    <version>4.3.12.RELEASE</version>
    <name>基础依赖版本管理</name>

    <properties>
        <springframework.version>4.3.12.RELEASE</springframework.version>
        <springboot.version>1.5.8.RELEASE</springboot.version>
    </properties>

    <dependencyManagement>
        <dependencies>
            <!-- 统一管理Spring依赖 -->
            <dependency>
                <groupId>org.springframework</groupId>
                <artifactId>spring-framework-bom</artifactId>
                <version>${springframework.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <!--通过Spring Boot管理其他第三方版本-->
            <dependency>
                <groupId>org.springframework.boot</groupId>
                <artifactId>spring-boot-dependencies</artifactId>
                <version>${springboot.version}</version>
                <type>pom</type>
                <scope>import</scope>
            </dependency>
            <!--其他-->
        </dependencies>
    </dependencyManagement>
</project>

注意两个依赖都是添加在 dependencyManagement 中,并且指定 <type>pom</type><scope>import</scope>import<scope> 中最特别的一个类型,这个类型只能用于这种情况。

同时要注意这两个依赖的顺序,越靠前面优先级越高。

如果你查看上面pom.xml 文件最终生成的 effective-pom,就会发现这是一个有 3000 多行的文件,这里面几乎包含了常见的各种依赖,少数不包含在内再额外添加即可。

除了上面的配置外,一个基础的 pom 还可以在增加一些常见插件的配置。下面是一个简单的示例。

 <build>
   <plugins>
     <plugin>
       <artifactId>maven-compiler-plugin</artifactId>
       <configuration>
         <source>1.8</source>
         <target>1.8</target>
       </configuration>
     </plugin>
   </plugins>
</build>

指定编译时的 JDK 版本是非常有必要的,尤其是在使用 IDEA 的情况下,这样可以避免 IDEA 选择 1.5 作为默认值的一些编译错误。由于不同环境使用的插件不太相同,所以这里只是一个示例,不需要按照这种方式使用。更合理的用法可能是创建一个插件的基础 pom(plugin-pom),然后在上面的的 pom 中设置 parent 为 plugin-pom,这样能满足更多情况下的选择。

阅读更多

扫码向博主提问

isea533

博客专家

MyBatis相关答疑
  • 擅长领域:
  • MyBatis
  • Spring Boo
  • Spring
去开通我的Chat快问

没有更多推荐了,返回首页